# Generated by Django 5.0.2 on 2024-02-23 13:01

import django.contrib.postgres.fields
import django.db.models.deletion
import django.utils.timezone
import model_utils.fields
import nemo.fields
import uuid
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('nemo', '0002_alter_workloaddocument_chart_and_more'),
    ]

    operations = [
        migrations.AlterField(
            model_name='workloaddocument',
            name='chart',
            field=models.OneToOneField(blank=True, help_text='The associated helm chart', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='document', to='nemo.workloaddocumentchart'),
        ),
        migrations.AlterField(
            model_name='workloaddocument',
            name='version',
            field=nemo.fields.SemVer2Field(db_index=True, help_text='A SemVer 2 version string', max_length=32, validators=[nemo.fields.SemVer2Field.validate_semver]),
        ),
        migrations.AlterField(
            model_name='workloaddocumentchart',
            name='version',
            field=nemo.fields.SemVer2Field(db_index=True, help_text='A SemVer 2 version string', max_length=32, validators=[nemo.fields.SemVer2Field.validate_semver]),
        ),
        migrations.AlterField(
            model_name='workloaddocumentchartdependency',
            name='version',
            field=nemo.fields.SemVer2Field(help_text='A SemVer 2 version string', max_length=32, validators=[nemo.fields.SemVer2Field.validate_semver]),
        ),
        migrations.CreateModel(
            name='WorkloadDocumentInstance',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', model_utils.fields.AutoCreatedField(default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('modified', model_utils.fields.AutoLastModifiedField(default=django.utils.timezone.now, editable=False, verbose_name='modified')),
                ('instance_id', models.UUIDField(db_index=True, default=uuid.uuid4, editable=False, help_text='NEMO unique workload document instance identifier', unique=True)),
                ('release_name', models.CharField(db_index=True, help_text='The workload document instance release name', max_length=100, unique=True)),
                ('status', models.CharField(choices=[('rendered', 'Rendered'), ('deployed', 'Deployed'), ('migrating', 'Migrating'), ('evicted', 'Evicted'), ('deleted', 'Deleted')], db_index=True, default='rendered', help_text='The workload document instance status')),
                ('manifests', django.contrib.postgres.fields.ArrayField(base_field=models.JSONField(), default=list, help_text='The generated instance manifests', size=None)),
                ('input_metadata', models.JSONField(help_text='The generated instance input metadata')),
                ('lifecycle_metadata', django.contrib.postgres.fields.ArrayField(base_field=models.JSONField(), blank=True, help_text='The lifecycle metadata associated with the instance', null=True, size=None)),
                ('cluster_name', models.CharField(blank=True, db_index=True, help_text='The NEMO cluster name that the instance recides in', max_length=100, null=True)),
                ('workload_document', models.ForeignKey(help_text='The workload document', on_delete=django.db.models.deletion.CASCADE, related_name='instances', to='nemo.workloaddocument')),
            ],
            options={
                'verbose_name': 'Workload Document Instance',
                'verbose_name_plural': 'Workload Document Instances',
                'db_table': 'workload_document_instance',
            },
        ),
    ]
